/*
 * Copyright (C) by Argonne National Laboratory
 *     See COPYRIGHT in top-level directory
 */

/* -- THIS FILE IS AUTO-GENERATED -- */

#include "mpiimpl.h"

/* -- Begin Profiling Symbol Block for routine MPIX_T_event_get_timestamp */
#if defined(HAVE_PRAGMA_WEAK)
#pragma weak MPIX_T_event_get_timestamp = PMPIX_T_event_get_timestamp
#elif defined(HAVE_PRAGMA_HP_SEC_DEF)
#pragma _HP_SECONDARY_DEF PMPIX_T_event_get_timestamp  MPIX_T_event_get_timestamp
#elif defined(HAVE_PRAGMA_CRI_DUP)
#pragma _CRI duplicate MPIX_T_event_get_timestamp as PMPIX_T_event_get_timestamp
#elif defined(HAVE_WEAK_ATTRIBUTE)
int MPIX_T_event_get_timestamp(MPI_T_event_instance event_instance, MPI_Count *event_timestamp)
     __attribute__ ((weak, alias("PMPIX_T_event_get_timestamp")));
#endif
/* -- End Profiling Symbol Block */

/* Define MPICH_MPI_FROM_PMPI if weak symbols are not supported to build
   the MPI routines */
#ifndef MPICH_MPI_FROM_PMPI
#undef MPIX_T_event_get_timestamp
#define MPIX_T_event_get_timestamp PMPIX_T_event_get_timestamp

#endif

/*@
   MPIX_T_event_get_timestamp - Returns the timestamp of when the event was initially observed by the implementation

Input Parameters:
. event_instance - event instance provided to the callback function (handle)

Output Parameters:
. event_timestamp - timestamp the event was observed (integer)

.N ThreadSafe

.N Errors
.N MPI_SUCCESS

.N MPI_T_ERR_INVALID
.N MPI_T_ERR_INVALID_HANDLE
.N MPI_T_ERR_NOT_INITIALIZED
.N MPI_ERR_OTHER

@*/

int MPIX_T_event_get_timestamp(MPI_T_event_instance event_instance, MPI_Count *event_timestamp)
{
    int mpi_errno = MPI_SUCCESS;
    MPIR_FUNC_TERSE_STATE_DECL(MPID_STATE_MPIX_T_EVENT_GET_TIMESTAMP);

    MPIT_ERRTEST_MPIT_INITIALIZED();

    MPIR_T_THREAD_CS_ENTER();
    MPIR_FUNC_TERSE_ENTER(MPID_STATE_MPIX_T_EVENT_GET_TIMESTAMP);

#ifdef HAVE_ERROR_CHECKING
    {
        MPID_BEGIN_ERROR_CHECKS;
        {
            MPIT_ERRTEST_EVENT_INSTANCE_HANDLE(event_instance);
            MPIT_ERRTEST_ARGNULL(event_timestamp);
        }
        MPID_END_ERROR_CHECKS;
    }
#endif /* HAVE_ERROR_CHECKING */

    /* ... body of routine ... */
    mpi_errno = MPIR_T_event_get_timestamp_impl(event_instance, event_timestamp);
    if (mpi_errno) {
        goto fn_fail;
    }
    /* ... end of body of routine ... */

  fn_exit:
    MPIR_FUNC_TERSE_EXIT(MPID_STATE_MPIX_T_EVENT_GET_TIMESTAMP);
    MPIR_T_THREAD_CS_EXIT();
    return mpi_errno;

  fn_fail:
    goto fn_exit;
}
